﻿using System;
using System.Security.Cryptography;
using System.Text;
using System.IO;
using System.Collections.Generic;

/// <summary>
/// Summary description for KullaniciHesabi
/// </summary>

public class KullaniciHesabi
{
    public string kullanici, sifre, soru, cevap;
    public List<AnaGrup> grup = new List<AnaGrup>();

    AnaGrup anaGrup;
    AltGrup altGrup;
    UnicodeEncoding ByteConverter = new UnicodeEncoding();
    RSACryptoServiceProvider RSA = new RSACryptoServiceProvider();
    byte[] SifreliVeri, dosya, safVeri;
    string privateKey;

    public bool HesabiOku(string kullan, string pass)
    {
        if (!File.Exists("c:\\xx\\" + kullanici + ".txt"))
            return false; // kullanıcı yok.

        List<string> strlist = new List<string>();
        int fileIndex = 0, anaGrupSayi, altGrupSayi;

        privateKey = File.ReadAllText("c:\\xx\\" + kullan + ".pri");
        RSA.FromXmlString(privateKey);
        dosya = File.ReadAllBytes("c:\\xx\\" + kullan + ".txt");

        Kopyala_128Byte(fileIndex, fileIndex + 128);
        fileIndex += 128; //sifre
        safVeri = RSA.Decrypt(SifreliVeri, false);
        sifre = ByteConverter.GetString(safVeri);

        if ( sifre != pass)
            return false;

        Kopyala_128Byte(fileIndex, fileIndex + 128);
        fileIndex += 128;
        safVeri = RSA.Decrypt(SifreliVeri, false);
        soru = ByteConverter.GetString(safVeri);

        Kopyala_128Byte(fileIndex, fileIndex + 128);
        fileIndex += 128;
        safVeri = RSA.Decrypt(SifreliVeri, false);
        cevap = ByteConverter.GetString(safVeri);

        for (; fileIndex < dosya.Length; ++fileIndex)
        {
            Kopyala_128Byte(fileIndex, fileIndex + 128);
            fileIndex += 128;
            safVeri = RSA.Decrypt(SifreliVeri, false);
            strlist.Add(ByteConverter.GetString(safVeri));
        }

        int index=0;
        anaGrupSayi = Convert.ToInt32(strlist[index++]);
        for (int i = 0,j; i < anaGrupSayi; ++i )
        {
            anaGrup = new AnaGrup();
            anaGrup.GrupAdi = strlist[index++];    //Grup adi ogreniliyor
            altGrupSayi = Convert.ToInt32(strlist[index++]); //Alt grup sayisi bulunuyor.

            for (j = 0; j < altGrupSayi; ++j)
            {
                altGrup = new AltGrup();
                altGrup.Sirket = strlist[index++];
                altGrup.Ekbilgi = strlist[index++];
                altGrup.Aciklama = strlist[index++];
                altGrup.Tarih = strlist[index++];
                altGrup.Sifre = strlist[index++];
                altGrup.Sure = Convert.ToInt32(strlist[index++]);
                altGrup.MinKarakter = Convert.ToInt32(strlist[index++]);
                altGrup.MinRakam = Convert.ToInt32(strlist[index++]);
                altGrup.MinBuyuk = Convert.ToInt32(strlist[index++]);
                altGrup.BasKarakter = Convert.ToInt32(strlist[index++]);
                anaGrup.YeniEkle(altGrup);
            }
            anaGrup.YeniEkle(altGrup);

        }
        return true;
    }

    private void Kopyala_128Byte(int bas, int son)
    {
        SifreliVeri = new byte[128];
        for (int i = bas, j = 0; i < son; ++i, ++j)
            SifreliVeri[j] = dosya[i];
    }

    public void HesabiKaydet(string kullan, string pass)
    {
        int anaGrupSayi, altGrupSayi;
        FileStream fs;
        fs = File.Create("c:\\xx\\" + kullanici + ".txt");

        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(sifre), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(soru), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(cevap), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);

        anaGrupSayi = grup.Count;
        for (int i = 0, j; i < anaGrupSayi; ++i)
        {
            SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(grup[i].GrupAdi), false);
            fs.Write(SifreliVeri, 0, SifreliVeri.Length);

            altGrupSayi = grup[i].Size; //Alt grup sayisi bulunuyor.
            for (j = 0; j < altGrupSayi; ++j)
            {
                altGrup = new AltGrup();
                altGrup = grup[i].getAltgrup(j);

                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Sirket), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Ekbilgi), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Aciklama), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Tarih), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Sifre), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.Sure.ToString()), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.MinKarakter.ToString()), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.MinRakam.ToString()), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.MinBuyuk.ToString()), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
                SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(altGrup.BasKarakter.ToString()), false);
                fs.Write(SifreliVeri, 0, SifreliVeri.Length);
            }
        }
    }
}
